/****************************************************************************
* NVMC                                                                      *
* Visual and Computer Graphics Library                                      *
*                                                                           *
* Copyright(C) 2007                                                         *
* ISTI - Italian National Research Council                                  *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History

$Log: packaging.cpp,v $
Revision 1.5  2007/03/27 23:10:29  ganovelli
added holes and tunnels to the Street
added buildings to the Circuit
added server to client transmission of each player state
added BRAKING and BOOSTING to the player state
added sun position

Revision 1.4  2007/03/21 10:34:22  ganovelli
added better steering,

Revision 1.3  2007/03/17 12:26:14  ganovelli
* pragma replaced by #ifndef directive
* Player operator= added
* bug in race_simulation.cpp corrected
* msvc2005 solutions added

Revision 1.2  2007/03/11 15:08:52  ganovelli
*** empty log message ***

Revision 1.1  2007/03/10 16:43:36  ganovelli
first working draft

Revision 1.5  2007/03/04 18:34:53  ganovell
*****************************************************************************/


#include "packaging.h"
#include <vcg/space/point4.h>

///
pt::string Pack(const  vcg::Point4f & f){ 
	pt::string s;
	int i;
	for(i = 0; i < 4; ++i)
			s += pt::string(pt::variant(f[i]))+pt::string(" ");
	return s;
}

///
pt::string Pack(const  float & v){ 
	return pt::string(pt::variant(v))+pt::string(" ");
}
///
pt::string Pack(const  Frame & frame){ 
	pt::string s,ds;
	int i,j;
	for(i = 0; i < 4; ++i)
		for(j = 0; j < 4; ++j)
			s += pt::string(pt::variant(frame[i][j]))+pt::string(" ");

	return s;
}

/// 
pt::string Pack(const int & v){
	return pt::string(pt::variant(v))+pt::string(" ");
}

///
C2SMessage UnPack(const pt::string & mess){
	C2SMessage m;
	m.header = atoi(&mess[0]);
	return m;
}

///
pt::string Pack(const C2SMessage & mess){
	char buffer[10];
	_itoa(mess.header,buffer,10);
	return pt::string(buffer);
}

